<?php
/*                                                                                                                                                       
  mememe                                     ememem
    \ememememem                       ememememem/ 
     ememememememem               ememememememem  
      emememememememe           emememememememe   
         \memememememem       ememememememe/      
         emememememememe     emememememememe     
                 emememem   ememememe              
                     ememe ememe                   
                       emememe                     
                         eme
                          e 

	^^ Title : ProvenExpert							 
	^^ Create : 2021-07-12
    ^^ For PS version 1.6, 1.7
	^^ Copyright : EAGLEMEDIA.de
*/

class ProvenExpertApi
{
 
    public static $cacheDirectory = '/cache'; 
    public static $cacheFile = '/provenexpert_3989971346dc6ac96e31d44eaaa12479.json';
    public static $cachePath = '/cache/provenexpert_3989971346dc6ac96e31d44eaaa12479.json';
    public static $cachingTime = 3600; // in seconds
    public static $errorFile = '/provenexpert_error.txt';
    public static $scriptVersion = '1.8';    
    public static $errors;
    public static $note; 
    public static $output;
    public static $ret;

    public static function setApiCachePath()    
    {    
        $res = false;
        
        if (file_exists(__DIR__ . self::$cacheDirectory)) {
            $res  = chmod(__DIR__ . self::$cacheDirectory, 0777);
            $res &= touch(__DIR__ . self::$cachePath, self::$cachingTime);
            $res &= chmod(__DIR__ . self::$cachePath, 0666);
            
            return (bool)$res;
        } 
        
        return (bool)$res;
    }

    public static function getApiRequestDetails($apiURL, $apiID, $apiKEY)
    {
        try {
            // check if a cache file exists and its age inside the caching time range
            if (!file_exists(__DIR__ . self::$cachePath) || (time() - filemtime(__DIR__ . self::$cachePath)) > self::$cachingTime) {
                // init curl handler
                $curlHandler = curl_init();

                // set curl options
                curl_setopt($curlHandler, CURLOPT_TIMEOUT, 3);
                curl_setopt($curlHandler, CURLOPT_RETURNTRANSFER, true);
                curl_setopt($curlHandler, CURLOPT_SSL_VERIFYPEER, false);
                curl_setopt($curlHandler, CURLOPT_URL, $apiURL . '?v=' . self::$scriptVersion);
                curl_setopt($curlHandler, CURLOPT_USERPWD, $apiID . ':' . $apiKEY);
                if (defined('CURLOPT_IPRESOLVE') && defined('CURL_IPRESOLVE_V4')) {
                    curl_setopt($curlHandler, CURLOPT_IPRESOLVE, CURL_IPRESOLVE_V4);
                }

                // send call to api
                $json = curl_exec($curlHandler);

                if ($json === false) {
                    // curl error
                    $errorMessage = 'curl error (' . date('c') . ')';
                    if (file_exists(__DIR__ . self::$cachePath)) {
                        $errorMessage .= PHP_EOL . PHP_EOL . 'last call: ' . date('c', filemtime(__DIR__ . self::$cachePath));
                    }
                    $errorMessage .= PHP_EOL . PHP_EOL . curl_error($curlHandler);
                    $errorMessage .= PHP_EOL . PHP_EOL . print_r(curl_version(), true);
                    file_put_contents(__DIR__ . self::$cacheDirectory . self::$errorFile, $errorMessage);
                    $json = json_encode(array('status' => 'error', 'errors' => array('curl error')));
                }
                curl_close($curlHandler);

                // convert json to array
                $data = json_decode($json, true);

                if (!is_array($data)) {
                    // json format is wrong
                    $errorMessage = 'json error (' . date('c') . ')' . PHP_EOL . PHP_EOL . $json;
                    if (file_exists(__DIR__ . self::$cachePath)) {
                        $errorMessage .= PHP_EOL . PHP_EOL . 'last call: ' . date('c', filemtime(__DIR__ . self::$cachePath));
                    }
                    file_put_contents(__DIR__ . self::$cacheDirectory . self::$errorFile, $errorMessage);
                    $data = array('status' => 'error', 'errors' => array('json error'));
                    $json = json_encode($data);
                }

                if ($data['status'] == 'success') {
                    if (is_writable(__DIR__ . self::$cachePath)) {
                        // save data in cache file
                        file_put_contents(__DIR__ . self::$cachePath, $json);
                    } else {
                        self::$errors[] = 'file access error [v' . self::$scriptVersion . ']';
                    }
                } elseif(!in_array('wrongPlan', $data['errors'])) {

                    if (file_exists(__DIR__ . self::$cachePath)) {
                        // it used the old data
                        $tmp = json_decode(file_get_contents(__DIR__ . self::$cachePath), true);

                        if (is_array($tmp)) {
                            $data = $tmp;
                            touch(__DIR__ . self::$cachePath, time() - round(self::$cachingTime / 10));
                            self::$errors[] = 'from cache because errors [v' . self::$scriptVersion . ']';
                        }
                    } else {
                        self::$errors[] = 'no caching';
                    }
                }
            } else {
                // get data from cache file
                $infoTime = self::$cachingTime;
                if (file_exists(__DIR__ . self::$cachePath)) {
                    $infoTime = (self::$cachingTime - (time() - filemtime(__DIR__ . self::$cachePath))) . '/' . $infoTime;
                }
                self::$note[] = 'from cache (' . $infoTime . ')';
                $data = json_decode(file_get_contents(__DIR__ . self::$cachePath), true);
            }

            // print aggregate rating html
            if ($data['status'] == 'success') {
                $ratingArray = explode('</style>', $data['aggregateRating']);                
                if (count($ratingArray) > 1) {
                    $style_content = str_replace('<style>', '', $ratingArray[0]);
                    // create css file when not exist and make this writable
                    if ( file_exists(__DIR__.'/views/css') )				
                        if ( touch(__DIR__.'/views/css/provenexpert_api.css') )          
                            chmod(__DIR__.'/views/css/provenexpert_api.css', 0777);								   

                    // check when curl_init is defined
                    if ( function_exists('curl_init') != false ){
                        // write style content in file                  
                        if ( $handle = fopen(__DIR__.'/views/css/provenexpert_api.css', 'w') ){ 
                            fputs( $handle, $style_content );
                            fclose( $handle );
                        }
                    }
                    
                    self::$output[] = $ratingArray[1];
                }
                else
                    self::$output[] = $data['aggregateRating'];
            } else {
                // sets the file as outdated
                touch(__DIR__ . self::$cachePath, self::$cachingTime);

                $errorMessage = 'response error';
                if (isset($data['errors']) && is_array($data['errors'])) {
                    $errorMessage .= ' (' . implode(', ', $data['errors']) . ')';
                }
                $errorMessage .= ' [v' . self::$scriptVersion . ']';

                self::$errors[] = $errorMessage;
            }
        } catch (Exception $e) {
            $errorMessage = 'exception' . PHP_EOL . PHP_EOL . $e->__toString();
            file_put_contents(__DIR__ . self::$cacheDirectory . self::$errorFile, $errorMessage);
            self::$errors[] = 'exception error [v' . self::$scriptVersion . ']';
        }   
        
        self::$ret['errors'] = self::$errors;
        self::$ret['errors'] = self::$note;       
        self::$ret['output'] = self::$output;        
        return self::$ret;       
    }

}
